package org.dromara.payment.sys.service;

import org.dromara.payment.common.domain.TranLog;
import org.dromara.payment.common.domain.vo.TranLogVo;
import org.dromara.payment.sys.domain.vo.SysSydCashoutVo;
import org.dromara.payment.sys.domain.bo.SysSydCashoutBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.settlement.api.domain.TransactionLog;

import java.util.Collection;
import java.util.List;

/**
 * 服务商提现记录Service接口
 *
 * @author LionLi
 * @date 2024-03-26
 */
public interface ISysSydCashoutService {

    /**
     * 查询服务商提现记录
     */
    SysSydCashoutVo queryById(Long id);

    /**
     * 查询服务商提现记录列表
     */
    TableDataInfo<SysSydCashoutVo> queryPageList(SysSydCashoutBo bo, PageQuery pageQuery);

    /**
     * 查询服务商提现记录列表
     */
    List<SysSydCashoutVo> queryList(SysSydCashoutBo bo);

    /**
     * 提现记录
     */
    Boolean insertByBo(SysSydCashoutBo bo);

    /**
     * 修改服务商提现记录
     */
    Boolean updateByBo(SysSydCashoutBo bo);

    /**
     * 校验并批量删除服务商提现记录信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 服务商提现业务
     * @param tlog 交易记录
     * @param tran 本次交易结果
     * @return
     */
    TranLog cashoutResult(TranLogVo tlog, TransactionLog tran);
}
